<?php
// $Id: taxonomy_treemenu.pages.inc,v 1.3 2009/08/02 19:48:20 rcrowther Exp $


// Unfortunately, I don't see any way round this. Using a hook on the taxonomy 
// node selector means generalizing across the installation, which seems ugly
//  and inefficient.
// So this is a near straight copy of taxonomy.pages.inc,
// with ttm's node selector put in, and lots stripped out.
/**
 * Menu callback; displays all nodes associated with a term.
 */
function taxonomy_treemenu_structured_term_output($ttm, $tid, $op = 'page') {
  if ($tid) {
    $result = db_query(db_rewrite_sql('SELECT t.tid, t.name FROM {term_data} t WHERE t.tid IN (%d)', 't', 'tid'), $tid);
    $term = db_fetch_object($result);
  
    if ($term) {
      $title = check_plain($term->name);
      drupal_set_title($title);
      switch ($op) {
        case 'page':
          $output = theme('taxonomy_treemenu_term_page', $term, taxonomy_treemenu_select_descendant_nodes2($ttm, $tid, TRUE));
          drupal_add_feed(url('taxonomy_treemenu/term/'. $tid .'/feed'), 'RSS - '. $title);
          return $output;
          break;
        // Ignoring feed until we run into it.
        default:
          drupal_not_found();
      }
    }
    else {
      drupal_not_found();
    }
  }
}

/**
 * Render a taxonomy term page HTML output.
 *
 * @param $tids
 *   An array of term ids.
 * @param $result
 *   A pager_query() result, such as that performed by taxonomy_select_nodes().
 *
 * @ingroup themeable
 */
function theme_taxonomy_treemenu_term_page($term, $result) {
  drupal_add_css(drupal_get_path('module', 'taxonomy') .'/taxonomy.css');

  $output = '';

  $description = $term->description;
  if (!empty($description)) {
    $output .= '<div class="taxonomy-term-description">';
    $output .= filter_xss_admin($description);
    $output .= '</div>';
  }

  $output .= taxonomy_render_nodes($result);

  return $output;
}


/*#?
 *
 */
/*
function taxonomy_treemenu_render_nodes($tid, $operator = 'and', $title = "", $description = "", $node_descriptions = TRUE) {
  //dpm('tr render nodes2:');
  //dvm($node_descriptions);
  $result = taxonomy_select_nodes($tids, $operator, 0, TRUE);
  $data['body'] = taxonomy_router_render_branch_list(FALSE, $result, $node_descriptions);
  //one or another of these may not be set in $data
  $data['vid'] = $vid;
  $data['tids'] = $tids;
  $data['is_terms'] = FALSE;
  $data['description'] = check_plain($description);
  $data['name'] = check_plain($title);
  return theme('page_branch_list', $data);
}
*/
/**
 * Implementation of template_preprocess_hook.
 */
/*
function template_preprocess_taxonomy_treemenu_view_term(&$variables) {
  //dpm('view term');
  $term = $variables['term'];
  $variables['tid'] = $term['tid'];
  $variables['vid'] = $term['vid'];
  $variables['title'] = check_plain($term['name']);
  $variables['description'] = check_markup($term['description']);
  $variables['body'] = $term['body'];
  //dpm($variables);
}


function taxonomy_treemenu_term_view($tid, $options, $node_base_path) {
  //dpm('tr render branches:');
  //dpm($url_data);
  $term = taxonomy_get_term($tid);
  $data['tid'] = $term->tid;
  $data['vid'] = $term->vid;
  $data['name'] = check_plain($term->name);
  $data['description'] = check_plain($term->description);

  $result = taxonomy_treemenu_select_descendant_nodes($tid, $options);
  $data['body'] = taxonomy_treemenu_render_node_list($result, $node_base_path);
  return theme('taxonomy_treemenu_view_term', $data);
}


function template_preprocess_taxonomy_treemenu_view_row_node(&$variables) {
  //dpm('ttpreprocess');
  $node_data = $variables['node_data'];
  $variables['separator'] = " ";
  $variables['title'] = check_plain($node_data['title']);
  $variables['node_url'] = $variables['base_path'] . '/' . $node_data['nid'];
  //dpm($variables['node_url']);
  //dpm($variables);
}

*/
/**
 * Menu callback; displays all nodes associated with a term.
 * Assumes $tid is validated.
 */
/*
function taxonomy_treemenu_render_node_list($result, $base_path) {
  //dpm('tt render node list:');
  //dpm($base_path);
  $output = '';
  $has_rows = FALSE;

  //$title = check_plain($term->name);
  //drupal_set_title($title);
  while($node_data = db_fetch_array($result)) {
    $output .= theme('taxonomy_treemenu_view_row_node', $node_data, $base_path);
    $has_rows = TRUE;
  }
  
  return $output;
  if ($has_rows) {
    //TODO: pager here$output = theme('taxonomy_treemenu_term_view', taxonomy_get_term($tid), );
  }
  else {
    $message = t('There are currently no nodes under this term.');
    $output .= '<p>'. $message .'</p>';
  }
  //dpm($output);
  return $output;
   // drupal_not_found();
}
*/
